###################parameters need to change################
library(randomForest)
library(reshape2)
#sample size
n=100

#elimination ratio
ratio = 1 / 10

#number of noise variables
sp=1000

set.seed(100)
###########################################################

##########################################################

set.seed(100)
x1=rnorm(n,1,1)
x2=rnorm(n,1,1)
x3=rnorm(n,1,1)

x4=rnorm(n,3,1)
x5=rnorm(n,3,1)
x6=rnorm(n,3,1)

y=1*x1+1*x2+1*x3+1*x4+1*x5+1*x6+rnorm(n,0,0.1)
  
  
x.noise=matrix(rnorm(sp*n,0,1),n,sp)

x=cbind(x1,x2,x3,x4,x5,x6,x.noise)
colnames(x)=paste("x",1:ncol(x),sep="")


#############Don't use backward elimination as GENIE3#####
par(mfrow=c(1,2))
a=proc.time()
res2=numeric()
for(i in 1:30){
  fit=randomForest(x=x,y=y)
  im=importance(fit,scale=TRUE)
  res2=cbind(res2,im[,1])
}
res2=t(res2)
m2=apply(res2, 2, mean)
m2=sort(m2,decreasing = TRUE)

names2=names(m2)[1:15]
ans2=melt(res2[,colnames(res2) %in% names2])
ans2$Var2=factor(ans2$Var2,levels = names2)

col=rep("blue",15)
indx=which(names2 %in% c("x1","x2","x3","x4","x5","x6"))
col[indx]="red"
boxplot(value~Var2,data=ans2,xlab="",ylab="importance score",
        col=col,xaxt="n",main="GENIE3")
axis(1, at=seq(1,15,by=1), labels=FALSE)
text(x=seq(1,15,by=1), y=par()$usr[3]-0.05*(par()$usr[4]-par()$usr[3]),
     labels=names2, srt=45, adj=1, xpd=TRUE,cex=0.6)
b=proc.time()
b-a
###########################################################
################Backward elimination#####################
a=proc.time()
while(ncol(x)>15){
  res=numeric()
  for(i in 1:30){
    fit=randomForest(x=x,y=y)
    im=importance(fit,scale=TRUE)
    res=cbind(res,im[,1])
  }
  res=t(res)
  m=apply(res, 2, mean)
  m=sort(m)
  n.to.el=floor(ncol(x)/10)
  x=x[,colnames(x) %in% names(m)[(n.to.el+1):ncol(x)]]
}
m=sort(m,decreasing = TRUE)
names1=names(m)[1:15]
ans1=melt(res[,colnames(res) %in% names1])
ans1$Var2=factor(ans1$Var2,levels = names1)

col=rep("blue",15)
indx=which(names1 %in% c("x1","x2","x3","x4","x5","x6"))
col[indx]="red"
boxplot(value~Var2,data=ans1,xlab="",ylab="importance score",
        col=col, xaxt="n",main="BWERF")
axis(1, at=seq(1,15,by=1), labels=FALSE)
text(x=seq(1,15,by=1), y=par()$usr[3]-0.05*(par()$usr[4]-par()$usr[3]),
     labels=names1, srt=45, adj=1, xpd=TRUE,cex=0.6)
b=proc.time()
b-a
