
###################parameters need to change################
#number of cores
ncore = 14

#pathway gene file name, the file must be .csv file
pathway_file = "./example_data/pathway_data.csv"

#TF file name, the file must be .csv file
tf_file = "./example_data/TF_data.csv"

#elimination ratio
ratio = 1 / 10

#the format of gene expression data, either "rowissample" or "colissample"
format = "colissample"

#output file name
out_file = "./output/bwerf_output.csv"

#the manner to cut-off TFs, either "assign" or "auto" 
mode = "assign"

#the number of layers of ML-GRN
num.layers = 3

#the numbers of TFs of eachlayer
nums.tf.eachlayer = c(20,10,5)
##############################################################


source("bwerf.R")


if (format == "rowissample") {
  pathway.data = read.csv(pathway_file,header = TRUE)
  tf.data = read.csv(tf_file,header = TRUE)
}else{
  pathway.data = read.csv(
    pathway_file,stringsAsFactors = FALSE,header = FALSE,row.names = 1
  )
  tf.data = read.csv(
    tf_file,stringsAsFactors = FALSE,header = FALSE,row.names = 1
  )
  pathway.data = t(as.matrix(pathway.data))
  tf.data = t(as.matrix(tf.data))
}
ans = multiLayer(
  tf.data, pathway.data, num.layers = num.layers, ratio = ratio, mode = mode, nums.tf.eachlayer =
    nums.tf.eachlayer, verbose = TRUE
)
write.csv(ans,file = out_file,row.names = FALSE)
